//
//	more Screensaver
//	Mike Lee
//
#include "more.h"
#include <String.h>
#include <StringView.h>
#include <CheckBox.h>
#include <stdlib.h>
#include <Alert.h>

// MAIN INSTANTIATION FUNCTION
extern "C" _EXPORT BScreenSaver *instantiate_screen_saver(BMessage *message, image_id image)
{
	return new Large(message, image);
}


Large::Large(BMessage *message, image_id image)
 : BScreenSaver(message, image)
{

}

void Large::StartConfig(BView *view)
{
	view->AddChild(new BStringView(BRect(10, 10, 200, 20), B_EMPTY_STRING, "moreofthebuggers"));
	view->AddChild(new BStringView(BRect(10, 25, 200, 35), B_EMPTY_STRING, "Build: 00003"));
	view->AddChild(new BStringView(BRect(10, 40, 200, 50), B_EMPTY_STRING, "By MLL"));

	view->AddChild(new BStringView(BRect(10, 95, 200, 105), B_EMPTY_STRING, "www.gasmic.org.uk"));

}


void Large::EndConfig(BView *view) 	{
}


void Large::StopSaver() {
	//delete [] tmp;
}

void Large::DirectConnected(direct_buffer_info *info) {
	if(firstrun) {
 		bits = (uint32 *) info->bits;
		tmp = new uint32[(height * width)];
		memcpy(tmp, bits, height * width * sizeof(uint32));
		firstrun = false;
	}
}

status_t Large::StartSaver(BView *view, bool  preview)
{
    if(preview) return B_ERROR;

	firstrun = true;
   BRect screenSize = view->Frame();  
    width = (int)screenSize.Width();
    height = (int)screenSize.Height();
	SetTickSize(50000);
	return B_OK;
}

#define TWO_D_TO_ONE_D(x, y) [ (x*(width+1)) + y]

void Large::DirectDraw(int32 frame)
{
   /*
   	REMEBER TO UP THE BUILD!
	*/
	 for(int i = 0; i< 2000; i++) {
		int curr = rand() % (height * width);
    	if(bits [curr] == tmp [curr])
 		  bits [curr] = rand() % 0xFFFFFF;
		else 
			bits [curr] = tmp [curr];
	 }

}
