//
//	Drunk Screensaver
//	Mike Lee
//
#include "DrunkVision.h"
#include <StringView.h>
#include <stdlib.h>
#include <Alert.h>

// MAIN INSTANTIATION FUNCTION
extern "C" _EXPORT BScreenSaver *instantiate_screen_saver(BMessage *message, image_id image)
{
	return new DrunkVision(message, image);
}

DrunkVision::DrunkVision(BMessage *message, image_id image)
 : BScreenSaver(message, image)
{

}

void DrunkVision::StartConfig(BView *view)
{
	view->AddChild(new BStringView(BRect(10, 10, 200, 20), B_EMPTY_STRING, "DrunkVision"));
	view->AddChild(new BStringView(BRect(10, 20, 200, 30), B_EMPTY_STRING, "Build: 0001"));
	view->AddChild(new BStringView(BRect(10, 30, 200, 40), B_EMPTY_STRING, "By MLL"));
	view->AddChild(new BStringView(BRect(10, 40, 200, 50), B_EMPTY_STRING, "www.gasmic.org.uk"));
}

void DrunkVision::DirectConnected(direct_buffer_info *info) {
 	bits = (uint32 *) info->bits;
}

status_t DrunkVision::StartSaver(BView *view, bool  preview)
{
    if(preview) return B_ERROR;

    BRect screenSize = view->Frame();  
    width = (int)screenSize.Width();
    height = (int)screenSize.Height();
	SetTickSize(0);
	one = false;
	return B_OK;
}

#define TWO_D_TO_ONE_D(x, y) [x*(width+1) + y]

void DrunkVision::DirectDraw(int32 frame)
{
   /*
   	REMEBER TO UP THE BUILD!
	*/

  if(one) {
  	for(int x = 0; x < width; x++) {
 	   if(rand() > 0.5) {
		uint32 tmp = bits TWO_D_TO_ONE_D(frame % height, x + 1);
	   	bits TWO_D_TO_ONE_D(frame % height, x + 1) = bits TWO_D_TO_ONE_D(frame%height, x);
		bits TWO_D_TO_ONE_D(frame%height, x ) = tmp;
	  }	  
	 }
   } else {
	  for(int x = 0; x < height-1; x++) {
 	   if(rand() > 0.5) {
		uint32 tmp = bits [(1+x)*(width+1) + frame % width];
	  	bits [(1+x)*(width+1) + frame % width] = bits [x*(width+1) + frame % width];
		bits [(x)*(width+1) + frame % width] = tmp;
	  }
	}
  }
	one =  !one;
}
